com.holonplatform.core.query

## Interface QueryConfiguration

- All Superinterfaces:
    Expression, ExpressionResolver.ExpressionResolverProvider, ParameterSet, Serializable

      public interface QueryConfiguration
      extends ParameterSet, Expression, ExpressionResolver.ExpressionResolverProvider

  Represents the configuration of a query, providing configuration elements and supporting `ExpressionResolver`s.
  Since:
    5.0.0

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface com.holonplatform.core.ParameterSet

      `ParameterSet.Builder<S extends ParameterSet>`

    - ### Nested classes/interfaces inherited from interface com.holonplatform.core.Expression

      `Expression.ExpressionResolverFunction<E extends Expression,R extends Expression>, Expression.InvalidExpressionException`

  - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `Optional<QueryAggregation>` | `getAggregation()` Get the query results aggregation clause.
    `Optional<QueryFilter>` | `getFilter()` Get the query filter.
    `Optional<Integer>` | `getLimit()` Get result set limit.
    `Optional<Integer>` | `getOffset()` Get 0-based results offset.
    `Optional<QuerySort>` | `getSort()` Get the query sort.
    `Optional<DataTarget<?>>` | `getTarget()` Get the data target.
    `boolean` | `isDistinct()` Get whether the query should return distinct query projection result values.

    - ### Methods inherited from interface com.holonplatform.core.ParameterSet

      `builder, empty, forEachParameter, getParameter, getParameter, getParameter, getParameter, getParameter, getParameterIf, getParameterIf, hasNotNullParameter, hasNotNullParameter, hasParameter, hasParameter, hasParameters, hasParameterValue, hasParameterValue`

    - ### Methods inherited from interface com.holonplatform.core.Expression

      `validate`

    - ### Methods inherited from interface com.holonplatform.core.ExpressionResolver.ExpressionResolverProvider

      `getExpressionResolvers`

- - ### Method Detail

    - #### getTarget

          Optional<DataTarget<?>> getTarget()

      Get the data target.
      Returns:
        Optional `DataTarget` of the query

    - #### getLimit

          Optional<Integer> getLimit()

      Get result set limit.
      Returns:
        Results limit, an empty Optional indicates no limit.

    - #### getOffset

          Optional<Integer> getOffset()

      Get 0-based results offset.
      Returns:
        Results offset 0-based index. an empty Optional indicates no offset.

    - #### getFilter

          Optional<QueryFilter> getFilter()

      Get the query filter.
      Returns:
        Optional query filter

    - #### getSort

          Optional<QuerySort> getSort()

      Get the query sort.
      Returns:
        Optional query sort

    - #### getAggregation

          Optional<QueryAggregation> getAggregation()

      Get the query results aggregation clause.
      Returns:
        Optional query results aggregation clause

    - #### isDistinct

          boolean isDistinct()

      Get whether the query should return distinct query projection result values.
      Returns:
        `true` if the query should return distinct query projection result values, `false` otherwise
      Since:
        5.2.0

Copyright © 2019 The Holon Platform. All rights reserved.